'FFSubmenu=Effekte
'FFName=Kacheln

'(c) Harald Maeckler, Dsseldorf 2009

' ********************************************************************
' Kacheln.vbs (Script fr FixFoto)
' nach einer Skriptvorlage von JKS am 08.03.2009
'
' Funktion:	Bild kacheln mit verschiedenen Transparenzen und Umrandung der Kacheln
'			Anzahl horizontal whlbar, Zufallsgenerator oder einstellbare Transparenz abwechselnd
'			Linienstrke und Linienfarbe knnen definiert werden
'
' Version 1.07 vom 02.07.2009	- Lschroutine hinzugefgt und KB entsprechend ergnzt
' Version 1.06 vom 16.04.2009	- Strke der Begrenzung auf 'nur ueren Bildrand' in Kacheln whlbar
'								  Die Begrenzung kann nur auf die Kachelumrandung eingeschrnkt werden
' Version 1.05 vom 15.04.2009	- Verbesserung der Bildflchenvergrerung
' Version 1.04 vom 15.04.2009	- nach Umrandung Vergrerung der Bildflche um halbe Strichstrke
' Version 1.03 vom 10.04.2009	- Option 'nur uerer Bildrand' hinzugefgt
'								- Eingabekontrollen eingefhrt
' Version 1.02 vom 09.04.2009	- Kachelumrandung hinzugefgt
' Version 1.01 vom 09.04.2009	- 'annhernd quadratisch' eingefhrt
' Version 1.00 vom 08.04.2009	- Betaversion
'
'** Start Kurzbeschreibung *******************************************
' Kacheln / Version 1.07
' ==============
' Das Skript dient der Kachelung des geladenen Bildes mit verschiedenen Transparenzen. 
' Auch die Umrandung der einzelnen Kacheln mit einer whlbaren Farbe ist mglich.
' Beides kann einzeln oder zusammen angewendet werden.
' Standardmig wird die gesamte Bildflche gekachelt. Wird allerdings die Option
' 'nur uerer Bildrand' aktiviert, wird nur die oberste und unterste Reihe und die
' linke und rechte Spalte gekachelt.
'
' Voreinstellung
' -----------------
' Als erstes gibt man die gewnschte Anzahl der Kacheln in der Horizontalen ein. Dann
' kann man sich entscheiden ob alle Kacheln 'genau quadratisch' sein sollen, oder ob
' 'annhernd quadratisch' ausreicht. 
'
' Whlt man 'genau quadratisch' werden abhngig vom Seitenverhltnis des Bildes und 
' der Kachelanzahl in der Regel die Kacheln der unteren Reihe abgeschnitten.
' Bei der Option 'annhernd quadratisch' wird die Kachelhhe so angepasst, dass sich
' auch in der Vertikalen eine ganzzahlige Anzahl von Kacheln ergibt. In den meisten
' Fllen ist die Abweichung vom Quadrat kaum sichtbar.
'
' Die Option 'nur uerer Bildrand' erlaubt, die Kachelumrandung rundherum auf eine 
' whlbare Kachelanzahl zu begrenzen. Wird dazu 'nur bei Kachelumrandung' aktiviert,
' gilt die Einschrnkung nur fr die Kachelumrandung. Ansonsten wird das ganze Bild 
' nach den eingestellten Transparenzwerten, falls aktiviert, gekachelt.
'
' Kacheltransparenz
' ----------------------
' Bei 'Transparenz zufllig verteilt' wird bei jeder Kachel ein Zufallswert angewendet.
' Jedesmal ergibt sich ein anderes Bild.
' Whlt man die Option 'Transparenz abwechselnd', wird der Einstellwert A und B abwechselnd
' angewendet. Dabei ist jede Reihe versetzt gegenber den benachbarten Reihen. Die Trans-
' parenzwerte lassen sich an den Reglern zwischen 0 und 255 einstellen.
'
' Kachelumrandung
' ---------------------
' Auf Wunsch knnen die einzelnen Kacheln umrandet werden. Dafr muss eine Linienstrke
' in Pixeln eingegeben und eine Linienfarbe gewhlt werden.
' Das Bild ist anschlieend in Breite und Hhe jeweils um die gewhlte Linienstrke
' grer.
'
' Deinstallation
' ========
' Wird die Entfernung des Skripts gewnscht, kann mit der Tastenkombination Alt + D eine 
' Lschroutine aufgerufen werden. Nach einer Sicherheitsabfrage wird berprft, ob das 
' zugehrige zip-Archiv im Skriptordner abgelegt ist. Wenn ja, wird vor dem Lschen angeboten,
' davon eine Sicherheitskopie an einem beliebigen Speicherort abzulegen. Danach werden nach-
' einander die Skriptdatei, die in der Registry dazugehrenden Daten und eventuelle Zusatz-
' dateien gelscht. Abschlieend wird die FixFotoScript.ini bereinigt.
' Nach manueller Durchfhrung einer 'Automatischen Skriptkonfiguration' ist das Skript mit 
' allen Komponenten aus der FixFoto-Umgebung entfernt.
'
'
' Benutzung des Skripts auf eigene Gefahr!
'
' Copyright Harald Maeckler
'** Ende Kurzbeschreibung ********************************************

Option Explicit

Dim Breite,Hoehe,SkriptKill,Antwort,TempFile				'Allgemein
Dim Anzahl,AnzahlV,Kachelbreite,Kachelhoehe,boolQuadrat		'Voreinstellung
Dim boolRahmen,boolNurUmrandung
const AuswahlKachelzahl = "1/2/3/4/5"
Dim boolTransparenz											'Transparenz
Dim Abwechselnd,Transparenz,TransparenzA,TransparenzB
Dim boolUmrandung,LinSt,LinFarbe,Farbe,LinFarbeCR,Kachelzahl'Kachelumrandung

const SkriptName = "Kacheln.vbs"							'Skriptname
Dim Kurzbeschreibung, KBvorhanden, LaengeMax, Abbruch		'Kurzbeschreibung
const ForReading = 1, ForWriting = 2, ForAppending = 8

Dim objFS,WshShell											'Objekte

'---------------------------------------------------------------------
call Main
'---------------------------------------------------------------------
Sub Main

Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

on error resume next									'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	Breite = FF_GetImageWidth()	'Breite
 	if Err.Number = 500 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if Breite = 0 then
	msgbox "Kein Bild geladen oder markiert!",vbCritical,"Abbruch"
	exit sub
end if

Randomize	'Zufallsstart einstellen

Hoehe = FF_GetImageHeight()

'** Start Dialog Kacheln **
FF_AddDialog "Kacheln",117,239
FF_AddControl "Kacheln","Voreinstellung","GROUP",5,5,107,62
FF_AddControl "Kacheln","Anzahl","SLEDIT",11,14,18,10
FF_SetControlStyle "Kacheln","Anzahl",8193
FF_AddControl "Kacheln","Kachelanzahl horizontal","STATIC",33,13,63,11
FF_AddControl "Kacheln","GenauQ","BOOL",17,26,8,8
FF_SetControlStyle "Kacheln","GenauQ",16384
FF_AddControl "Kacheln","genau quadratisch","STATIC",33,24,63,11
FF_AddControl "Kacheln","UngefaehrQ","BOOL",17,36,8,8
FF_SetControlStyle "Kacheln","UngefaehrQ",16384
FF_AddControl "Kacheln","annhernd quadratisch","STATIC",33,34,63,11
FF_AddControl "Kacheln","Rahmen","BOOL",24,46,8,8
FF_SetControlStyle "Kacheln","Rahmen",16384
FF_AddControl "Kacheln","nur u. Bildrand mit","STATIC",33,44,50,11
FF_AddControl "Kacheln","Kachelzahl","COMBO",84,44,15,9
FF_AddControl "Kacheln","K.","STATIC",102,44,5,10
FF_AddControl "Kacheln","nurUmrandung","BOOL",32,56,8,8
FF_AddControl "Kacheln","nur bei Kachelumrandung","STATIC",43,53,67,12
FF_AddControl "Kacheln","Kacheltransparenz","GROUP",5,70,107,109
FF_AddControl "Kacheln","boolTransparenz","BOOL",96,70,8,8
FF_AddControl "Kacheln","Zufall","BOOL",17,80,8,8
FF_SetControlStyle "Kacheln","Zufall",16384
FF_AddControl "Kacheln","Transparenz zufllig verteilt","STATIC",33,79,76,11
FF_AddControl "Kacheln","Abwechselnd","BOOL",17,90,8,8
FF_SetControlStyle "Kacheln","Abwechselnd",16384
FF_AddControl "Kacheln","Transparenz abwechselnd","STATIC",33,88,70,11
FF_AddControl "Kacheln","und einstellbar mit A und B","STATIC",33,97,70,11
FF_AddControl "Kacheln","AnzKA","SLEDIT",11,108,18,10
FF_SetControlStyle "Kacheln","AnzKA",2049
FF_AddControl "Kacheln","KachelA","HSLIDER",14,119,94,22
FF_AddControl "Kacheln","Einstellung A","STATIC",71,108,33,11
FF_AddControl "Kacheln","AnzKB","SLEDIT",11,143,18,10
FF_SetControlStyle "Kacheln","AnzKB",2049
FF_AddControl "Kacheln","KachelB","HSLIDER",14,154,94,23
FF_AddControl "Kacheln","Einstellung B","STATIC",70,143,33,11
FF_AddControl "Kacheln","Kachelumrandung","GROUP",5,182,107,37
FF_AddControl "Kacheln","boolUmrandung","BOOL",96,182,8,8
FF_AddControl "Kacheln","Staerke","SLEDIT",11,192,18,10
FF_SetControlStyle "Kacheln","Staerke",8193
FF_AddControl "Kacheln","Linienstrke [px]","STATIC",55,192,53,12
FF_AddControl "Kacheln","Farbe","COLOR",10,205,33,10
FF_AddControl "Kacheln","Linienfarbe","STATIC",56,204,54,11
FF_AddControl "Kacheln","?","BUTTON",11,224,11,11
FF_AddControl "Kacheln","Start","BUTTON",76,224,33,11
FF_AddControl "Kacheln","&d","BUTTON",35,224,1,1
'** End Dialog Kacheln **

call RegistryLesen

FF_SetControlBuddy "Kacheln","KachelA","AnzKA"
FF_SetControlBuddy "Kacheln","KachelB","AnzKB"
FF_ActivateControl "Kacheln","&d"

do									'Befehlsabfrage
	Select Case FF_ShowDialog ("Kacheln")
	Case "&d"
		Abbruch = false
		SkriptKill = false
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 " mit allen dazugehrigen Komponenten wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "GenauQ"
		if FF_GetControl("Kacheln","GenauQ") = 0 then
			FF_SetControl "Kacheln","GenauQ",1
		else
			FF_SetControl "Kacheln","UngefaehrQ",0
		end if
	Case "UngefaehrQ"
		if FF_GetControl("Kacheln","UngefaehrQ") = 0 then
			FF_SetControl "Kacheln","UngefaehrQ",1
		else
			FF_SetControl "Kacheln","GenauQ",0
		end if
	Case "Rahmen"
		if FF_GetControl("Kacheln","Rahmen") = 1 then
			FF_EnableControl "Kacheln","GenauQ",false
			FF_EnableControl "Kacheln","UngefaehrQ",false
			FF_SetControl "Kacheln","GenauQ",0
			FF_SetControl "Kacheln","UngefaehrQ",1
			FF_EnableControl "Kacheln","nurUmrandung",true
		else
			FF_EnableControl "Kacheln","GenauQ",true
			FF_EnableControl "Kacheln","UngefaehrQ",true
			FF_EnableControl "Kacheln","nurUmrandung",false
		end if
	Case "Zufall"
		FF_SetControl "Kacheln","Abwechselnd",0
	Case "Abwechselnd"
		FF_SetControl "Kacheln","Zufall",0
	Case "?"
		Abbruch = false
		if not KBvorhanden then	call KurzbeschreibungLesen
		if KBvorhanden then
			call KurzbeschreibungAnzeigen
		else
			msgbox "Keine Kurzbeschreibung gefunden!",vbExclamation,"Meldung"
		end if
	Case "Start"
		call WerteAuslesen
		if FF_GetControl("Kacheln","boolUmrandung") = 0 and FF_GetControl("Kacheln","boolTransparenz") = 0 then
			msgbox "Es ist weder Kacheltransparenz noch Kachelumrandung angewhlt!",vbInformation,"Hinweis"
		elseif FF_GetControl("Kacheln","boolUmrandung") = 1 and FF_GetControl("Kacheln","Staerke") < 1 then
			msgbox "Die Linienstrke muss mindestens 1 Pixel betragen!",vbInformation,"Hinweis"
		elseif FF_GetControl("Kacheln","Rahmen") = 1 and (Kachelzahl > Anzahl/2 or Kachelzahl > AnzahlV/2) then
			msgbox "Die bei der Option 'nur uerer Bildrand' gewhlte Kachelzahl ist zu hoch." & vbNewLine & _
				   "Sie muss kleiner sein als die Hlfte der Kachelanzahl in der Vertikalen " & _
				   "und in der Horizontalen.",vbInformation,"Hinweis"
		else
			if boolRahmen = 1 then
				if boolNurUmrandung = 1 then
					if boolTransparenz = 1 then call Kachelvorgang
				else
					if boolTransparenz = 1 then call KachelvorgangR
				end if
				if boolUmrandung = 1 then call UmrandungR
			else	
				if boolTransparenz = 1 then call Kachelvorgang
				if boolUmrandung = 1 then call Umrandung
			end if
			FF_Reload()
			exit do
		end if
	Case "CANCEL"
		exit do
	Case Else
	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("Kacheln")
if SkriptKill then call KillSkript	'ggf. Skript komplett entfernen

End Sub
'---------------------------------------------------------------------
Sub KachelvorgangR
'nur den Bildrand kacheln

Dim a,b			'Zhlfaktoren
Dim modX,modY	'gerade oder ungerade
Dim y,x			'Horizontal- und Vertikalkoordinaten

Randomize
Kachelzahl = Kachelzahl*1
for a = 0 to AnzahlV		'Vertikal

	modX = a mod 2
	y = int(Kachelhoehe * a)
	
	if a < Kachelzahl or a > (AnzahlV - Kachelzahl - 1) then
		'Kacheln der obersten und untersten Reihe
		for b = 1 to Anzahl		'Horizontal
			modY = b mod 2
			x = int(Kachelbreite * (b-1))
			if Abwechselnd = 1 then
				if (modX xor modY) = 0 then
					Transparenz = TransparenzA
				else
					Transparenz = TransparenzB
				end if
			else
				Transparenz = Int((255 * Rnd))
			end if
			FF_AreaFillRect x,y,x+Kachelbreite +.5,y+Kachelhoehe +.5,Transparenz
		next
	else
		for b = 1 to Anzahl
			'Kacheln des linken Rand
			if b < (Kachelzahl + 1) then
				modY = b mod 2
				x = int(Kachelbreite * (b-1))
				if Abwechselnd = 1 then
					if (modX xor modY) = 0 then
						Transparenz = TransparenzA
					else
						Transparenz = TransparenzB
					end if
				else
					Transparenz = Int((255 * Rnd))
				end if
				FF_AreaFillRect x,y,x+Kachelbreite +.5,y+Kachelhoehe +.5,Transparenz
			end if
		
			'Kacheln des rechten Rand
			if b >= (Anzahl + 1 - Kachelzahl) then
				modY = b mod 2
				x = int(Kachelbreite * (b-1))
				if Abwechselnd = 1 then
					if (modX xor modY) = 0 then
						Transparenz = TransparenzA
					else
						Transparenz = TransparenzB
					end if
				else
					Transparenz = Int((255 * Rnd))
				end if
				FF_AreaFillRect x,y,x+Kachelbreite +.5,y+Kachelhoehe +.5,Transparenz
			end if
		next
	end if
next		

FF_LinContrast(2.)

End Sub
'------------------------------------------------------------------------
Sub Kachelvorgang
'gesamte Bildflche kacheln

Dim a,b			'Zhlfaktoren
Dim modX,modY	'gerade oder ungerade
Dim y,x			'Horizontal- und Vertikalkoordinaten

Randomize
for a = 0 to AnzahlV		'Vertikal
	modX = a mod 2
	if boolQuadrat = 1 then
		y = int(Kachelbreite * a)
	else
		y = int(Kachelhoehe * a)
	end if
	
	for b = 1 to Anzahl		'Horizontal
		modY = b mod 2
		x = int(Kachelbreite * (b-1))
		if Abwechselnd = 1 then
			if (modX xor modY) = 0 then
				Transparenz = TransparenzA
			else
				Transparenz = TransparenzB
			end if
		else
			Transparenz = Int((255 * Rnd))
		end if
		FF_AreaFillRect x,y,x+Kachelbreite +.5,y+Kachelhoehe +.5,Transparenz
	next

next		

FF_LinContrast(2.)

End Sub
'------------------------------------------------------------------------
Sub UmrandungR
'nur die ueren Kacheln umranden
'FF_Line (xstart,ystart,xend,yend,LinFarbeCR,LinSt) 'Vorlage

Dim a	'Zhlvariable

for a = 0 to Kachelzahl													'horiz. durchgehende Linien oben
	call FF_Line (0,a*Kachelhoehe,Breite,a*Kachelhoehe,LinFarbeCR,LinSt)	
next

for a = 2 to AnzahlV - 2												'weitere horiz. Striche
	call FF_Line (0,a * Kachelhoehe,Kachelzahl*Kachelbreite,a * Kachelhoehe,LinFarbeCR,LinSt)
	call FF_Line (Breite - Kachelbreite*Kachelzahl,a * Kachelhoehe,Breite,a * Kachelhoehe,LinFarbeCR,LinSt)
next

for a = 0 to Kachelzahl													'horiz. durchgehende Linien unten
	call FF_Line (0,Hoehe - Kachelhoehe*a,Breite,Hoehe - Kachelhoehe*a,LinFarbeCR,LinSt)
next

for a = 0 to Kachelzahl													'vert. durchgehende Linien links
	call FF_Line (Kachelbreite*a,0,Kachelbreite*a,Hoehe,LinFarbeCR,LinSt)
next

for a = 2 to Anzahl - 2													'weitere vert. Striche
	call FF_Line (a * Kachelbreite,0,a * Kachelbreite,Kachelzahl*Kachelhoehe,LinFarbeCR,LinSt)
	call FF_Line (a * Kachelbreite,Hoehe - Kachelzahl*Kachelhoehe,a * Kachelbreite,Hoehe,LinFarbeCR,LinSt)
next

for a = 0 to Kachelzahl													'vert. durchgehende Linien rechts
	call FF_Line (Breite - Kachelbreite*a,0,Breite - Kachelbreite*a,Hoehe,LinFarbeCR,LinSt)
next

'Bildflche vergrern um halbe Strichstrke
LinSt = round(LinSt/2 + .5)
FF_ExtendCanvas LinSt,LinSt,LinSt,LinSt,Farbe(0),Farbe(1),Farbe(2)
call FF_Line (Breite+LinSt,0,Breite+LinSt,Hoehe+Linst,LinFarbeCR,LinSt)	'letzte vert. Linie

End Sub
'------------------------------------------------------------------------
Sub Umrandung
'die gesamte Flche umranden
Dim Wert,xstart,ystart,xend,yend
Wert = 0 : xstart = 0 : xend = Breite

do											'horizontale Linien
	ystart = Wert
	yend = ystart
	if ystart > Hoehe then exit do
	call FF_Line (xstart,ystart,xend,yend,LinFarbeCR,LinSt)
	Wert = Wert + Kachelhoehe
loop

Wert = 0 : ystart = 0 : yend = Hoehe
do											'vertikale Linien
	xstart = Wert
	xend = xstart
	if xstart > Breite then exit do
	call FF_Line (xstart,ystart,xend,yend,LinFarbeCR,LinSt)
	Wert = Wert + Kachelbreite
loop

'Bildflche vergrern um halbe Strichstrke
LinSt = round(LinSt/2 + .5)
FF_ExtendCanvas LinSt,LinSt,LinSt,LinSt,Farbe(0),Farbe(1),Farbe(2)
call FF_Line (Breite+LinSt,0,Breite+LinSt,Hoehe+Linst,LinFarbeCR,LinSt)					'letzte vert. Linie

End Sub
'------------------------------------------------------------------------
Sub WerteAuslesen

'Voreinstellung
Anzahl = FF_GetControl("Kacheln","Anzahl")
boolQuadrat = FF_GetControl("Kacheln","GenauQ")
Kachelbreite = Breite / Anzahl
AnzahlV = round(Hoehe / Kachelbreite)
if boolQuadrat = 1 then
	Kachelhoehe = Kachelbreite
else
	Kachelhoehe = Hoehe / AnzahlV
end if
boolRahmen = FF_GetControl("Kacheln","Rahmen")
Kachelzahl = FF_GetControl("Kacheln","Kachelzahl") * 1
boolNurUmrandung = FF_GetControl("Kacheln","nurUmrandung")

'Kacheltransparenz
boolTransparenz = FF_GetControl("Kacheln","boolTransparenz")
Abwechselnd = FF_GetControl("Kacheln","Abwechselnd")
TransparenzA = FF_GetControl("Kacheln","AnzKA")
TransparenzB= FF_GetControl("Kacheln","AnzKB")

'Kachelumrandung
boolUmrandung = FF_GetControl("Kacheln","boolUmrandung")

LinSt = FF_GetControl("Kacheln","Staerke")
LinFarbe = FF_GetControl("Kacheln","Farbe")	'Umwandlung in colorref
Farbe = split(LinFarbe," ")
LinFarbeCR = Farbe(0) * 1 + Farbe(1) * (2^8) + Farbe(2) * (2^16)

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungAnzeigen

Dim Taste
Dim BreiteKB	: BreiteKB = LaengeMax * 2.6 + 15
const Hoehe = 180

const ES_READONLY = 2048
const WS_VSCROLL = 2097152

FF_AddDialog "Kurzbeschreibung",BreiteKB,Hoehe
FF_AddControl "Kurzbeschreibung","Beschreibung","EDIT",0,0,BreiteKB,Hoehe-20
FF_SetControlStyle "Kurzbeschreibung","Beschreibung", ES_READONLY + WS_VSCROLL
FF_AddControl "Kurzbeschreibung","OK","BUTTON",BreiteKB/2-15,Hoehe-15,30,10

FF_SetControl "Kurzbeschreibung","Beschreibung",Kurzbeschreibung

do
	Taste = FF_ShowDialog("Kurzbeschreibung")
	if Taste = "CANCEL" or Taste = "OK" then exit do
loop
call FF_CloseDialog("Kurzbeschreibung")

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungLesen
on error resume next
Const ForReading = 1
Dim Skript, Anfang, Ende, Zeile, ZZ

Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)

if err.number = 53 then
	msgbox "Wahrscheinlich wurde der Originalskriptname " & """" & SkriptName & """" & " abgendert." & vbNewLine & _
		   "Die Kurzbeschreibung kann daher nicht angezeigt werden.",vbExclamation,"Meldung"
	Abbruch = True
	exit sub
end if

Do While Skript.AtEndOfStream <> True
	Zeile = Skript.ReadLine
	
	ZZ = ZZ + 1
	if ZZ > 1000 then msgbox "Fehler in der Kurzbeschreibung! (objFS?)" : exit sub
	
	if instr(Zeile,"** Ende Kurzbeschreibung") > 0 then Ende = true
	if Ende then exit do
	
	if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
	if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
	
	if instr(Zeile,"** Start Kurzbeschreibung") > 0 then Anfang = true
	
Loop
	
if Anfang and Ende then KBvorhanden = true
Skript.Close

End Sub
'------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\FF_Kacheln
Dim KachelAnzeige,element

'### Werte auslesen
Anzahl = FF_GetProfile("FF_Kacheln","Anzahl")					'Voreinstellung
if Anzahl = "" then Anzahl = 10
boolQuadrat = FF_GetProfile("FF_Kacheln","boolQuadrat")
if boolQuadrat = "" then boolQuadrat = 1
boolRahmen = FF_GetProfile("FF_Kacheln","boolRahmen")
if boolRahmen = "" then boolRahmen = 0
Kachelzahl = FF_GetProfile("FF_Kacheln","Kachelzahl")
if Kachelzahl = "" then Kachelzahl = 2
boolNurUmrandung = FF_GetProfile("FF_Kacheln","boolNurUmrandung")

boolTransparenz = FF_GetProfile("FF_Kacheln","boolTransparenz")	'Transparenz
if boolTransparenz = "" then boolTransparenz = 1
Abwechselnd = FF_GetProfile("FF_Kacheln","Abwechselnd")
if Abwechselnd = "" then Abwechselnd = 1
TransparenzA = FF_GetProfile("FF_Kacheln","TransparenzA")
if TransparenzA = "" then TransparenzA = 0
TransparenzB = FF_GetProfile("FF_Kacheln","TransparenzB")
if TransparenzB = "" then TransparenzB = 255

boolUmrandung = FF_GetProfile("FF_Kacheln","boolUmrandung")		'Umrandung
if boolUmrandung = "" then boolUmrandung = 0
LinSt = FF_GetProfile("FF_Kacheln","LinSt")
if LinSt = "" then LinSt = 2
LinFarbe = FF_GetProfile("FF_Kacheln","LinFarbe")
if LinFarbe = "" then LinFarbe = "000 000 000"

'### Werte eintragen
FF_SetControl "Kacheln","Anzahl",Anzahl							'Voreinstellung
FF_SetControl "Kacheln","Rahmen",boolRahmen
if boolRahmen = 1 then
	boolQuadrat = 0
	FF_EnableControl "Kacheln","GenauQ",false
	FF_EnableControl "Kacheln","UngefaehrQ",false
else
	FF_EnableControl "Kacheln","nurUmrandung",false
end if
if boolQuadrat = 1 then
	FF_SetControl "Kacheln","GenauQ",1
else
	FF_SetControl "Kacheln","UngefaehrQ",1
end if
KachelAnzeige = split(AuswahlKachelzahl,"/")
for each element in KachelAnzeige
	FF_SetControl "Kacheln","Kachelzahl",element
next
FF_SetControl "Kacheln","Kachelzahl",Kachelzahl
FF_SetControl "Kacheln","nurUmrandung",boolNurUmrandung

FF_SetControl "Kacheln","boolTransparenz",boolTransparenz		'Transparenz
if Abwechselnd = 1 then
	FF_SetControl "Kacheln","Abwechselnd",1
else
	FF_SetControl "Kacheln","Zufall",1
end if
FF_SetControl "Kacheln","KachelA",TransparenzA
FF_SetControl "Kacheln","KachelB",TransparenzB

FF_SetControl "Kacheln","boolUmrandung",boolUmrandung			'Umrandung
FF_SetControl "Kacheln","Staerke",LinSt	
FF_SetControl "Kacheln","Farbe",LinFarbe

End Sub
'------------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\FF_Kacheln

'### Werte auslesen
call WerteAuslesen

'### Werte eintragen
FF_WriteProfile "FF_Kacheln","Anzahl",Anzahl					'Voreinstellung
FF_WriteProfile "FF_Kacheln","boolQuadrat",boolQuadrat
FF_WriteProfile "FF_Kacheln","boolRahmen",boolRahmen
FF_WriteProfile "FF_Kacheln","Kachelzahl",Kachelzahl
FF_WriteProfile "FF_Kacheln","boolNurUmrandung",boolNurUmrandung

FF_WriteProfile "FF_Kacheln","boolTransparenz",boolTransparenz	'Transparenz
FF_WriteProfile "FF_Kacheln","Abwechselnd",Abwechselnd
FF_WriteProfile "FF_Kacheln","TransparenzA",TransparenzA
FF_WriteProfile "FF_Kacheln","TransparenzB",TransparenzB

FF_WriteProfile "FF_Kacheln","boolUmrandung",boolUmrandung		'Umrandung
FF_WriteProfile "FF_Kacheln","LinSt",LinSt
FF_WriteProfile "FF_Kacheln","LinFarbe",LinFarbe

End Sub
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad
const RegSchluessel = "\FF_Kacheln\"

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien und Ordner lschen
'TempFile = FF_GetScriptPath & "\Beipack.txt"		'Dateibeispiel
'if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

'TempFile = FF_GetScriptPath & "\BeipackSammlung"	'Ordnerbeispiel
'if objFS. FolderExists (TempFile) then objFS. DeleteFolder TempFile,true

'### Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script" & RegSchluessel
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Nach Durchfhrung der 'Automatischen Skriptkonfiguration' ist das Skript" & vbNewLine & _
		Skriptname & " mit allen Komponenten gelscht!",vbExclamation,"Hinweis"
End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
